



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>lazyload懒加载的使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">lazyload懒加载的使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 03:41:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1.引用&lt;script src="http://a.tbcdn.cn/apps/baron/js/??lib/tmm/tmm.js,lib/lazyload/lazyload.js?20121015"&gt;&lt;/script&gt;</p>
<p>2.对于要懒加载的图片进行如下属性设置。&lt;img src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://img03.taobaocdn.com/tps/i3/T1xl4_FlFaXXcLmU_5-305-317.png" /&gt;</p>
<p>其中src为未加载时的图片，dataimg为实际要加载的图片。</p>
<p>3.执行lazyload.init();</p>
<p>4.分tab的懒加载。判断tab把下面的图片有没加载过。根据loaded属性判断，还要对非当前tab所属的图片进行class lazy去掉。对已加载的loaded为true的图片，不加lazy属性</p>
<p>5.注意lazyload.init()的执行时机，如果在dom ready阶段执行，会下载所有图片，不能实现懒加载。要在winow.onload完成这个阶段去执行。</p>
<p>lazyload.js代码解读：</p>
<div>
<pre class="prettyprint linenums">/**<br />
 * 基于jQuery或者zeptoJS的惰性加载<br />
 */<br />
var lazyload = {<br />
  init : function(opt){<br />
    var that = this;<br />
    var op = {<br />
        anim: true,<br />
        extend_height:400<br />
    };<br />
    // 合并对象，已有的{anim:true}+用户自定义对象。也就是op = op + opt<br />
    $.extend(op,opt);<br />
    // 调用lazyload.img.init(op)函数<br />
    that.img.init(op);

  },

  img : {<br />
    init : function(n){

      var that = this;<br />
      console.log(n);

      // 要加载的图片是不是在指定窗口内<br />
      function inViewport( el ) {<br />
          // 当前窗口的顶部<br />
        var top = window.pageYOffset<br />
        // 当前窗口的底部<br />
        var btm = window.pageYOffset + window.innerHeight<br />
        // 元素所在整体页面内的y轴位置<br />
        var elTop = $(el).offset().top;<br />
        // 判断元素，是否在当前窗口，或者当前窗口延伸400像素内<br />
        return elTop &gt;= top &amp;&amp; elTop - n.extend_height &lt;= btm<br />
      }

      // 滚动事件里判断，加载图片<br />
       $(window).bind('scroll', function() {<br />
          $('img.lazy').each(function(index,node) {<br />
            var $this = $(this)<br />
            if(!$this.attr('dataimg')){<br />
              return<br />
            }<br />
            if ( !inViewport(this) ) return<br />
            act($this)

          })<br />
        }).trigger('scroll')

       // 展示图片<br />
       function act(_self){<br />
              // 已经加载过了，则中断后续代码<br />
           if (_self.attr('loaded')) return;<br />
            var img = new Image(), original = _self.attr('dataimg')<br />
            // 图片请求完成后的事件，把dataimg指定的图片，放到src里面，浏览器显示<br />
            img.onload = function() {<br />
                _self.attr('src', original).removeClass('lazy');<br />
                n.anim &amp;&amp; _self.css({ opacity: .2 }).animate({ opacity: 1 }, 280);<br />
            }<br />
            // 当你设置img.src的时候，浏览器就在发送图片请求了<br />
            original &amp;&amp; (img.src = original);<br />
             _self.attr('loaded', true);<br />
       }<br />
    }<br />
  }<br />
};</pre>
</div>
<p>2015年6月30日添加用例</p>
<div>
<pre class="prettyprint linenums">&lt;!doctype html&gt;<br />
&lt;html lang="en"&gt;

    &lt;head&gt;<br />
        &lt;meta charset="UTF-8" /&gt;<br />
        &lt;title&gt;懒加载实例&lt;/title&gt;<br />
        &lt;style type="text/css"&gt;<br />
        /*一定要有预先高度*/<br />
            img{<br />
                width: 600px;<br />
                height: 260px;<br />
            }<br />
        &lt;/style&gt;<br />
    &lt;/head&gt;

    &lt;body&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/11de79502d0af.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/33f99f823ed3d.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/680120973b82.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/67f87ba08cf0.jpg!v1sell" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/22ec075a17c33.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/2e4a699680788.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/c2f4043a4991.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
        &lt;div&gt;<br />
            &lt;img class="samLazyImg" src="http://a.tbcdn.cn/mw/webapp/fav/img/grey.gif" dataimg="http://yangege.b0.upaiyun.com/33f996b4386ab.jpg!v1sell" alt="" /&gt;<br />
        &lt;/div&gt;<br />
    &lt;/body&gt;<br />
    &lt;script src="jquery-2.1.4.min.js" type="text/javascript" charset="utf-8"&gt;&lt;/script&gt;<br />
    &lt;script type="text/javascript"&gt;<br />
        var lazyload = {<br />
          init : function(opt){<br />
            var that = this,<br />
            op = {<br />
                anim: true,<br />
                extend_height:0,<br />
                selectorName:"img",<br />
                realSrcAtr:"dataimg"<br />
            };<br />
            // 合并对象，已有的{anim:true}+用户自定义对象。也就是op = op + opt<br />
            $.extend(op,opt);<br />
            // 调用lazyload.img.init(op)函数<br />
            that.img.init(op);

          },

          img : {<br />
            init : function(n){

              var that = this,<br />
              selectorName = n.selectorName,<br />
              realSrcAtr = n.realSrcAtr,<br />
              anim = n.anim;<br />
//              console.log(n);

              // 要加载的图片是不是在指定窗口内<br />
              function inViewport( el ) {<br />
                  // 当前窗口的顶部<br />
                var top = window.pageYOffset,<br />
                // 当前窗口的底部<br />
               btm = window.pageYOffset + window.innerHeight,<br />
                // 元素所在整体页面内的y轴位置<br />
               elTop = $(el).offset().top;<br />
                // 判断元素，是否在当前窗口，或者当前窗口延伸400像素内<br />
                return elTop &gt;= top &amp;&amp; elTop - n.extend_height &lt;= btm;<br />
              }

              // 滚动事件里判断，加载图片<br />
               $(window).on('scroll', function() {<br />
                  $(selectorName).each(function(index,node) {<br />
                    var $this = $(this);

                    if(!$this.attr(realSrcAtr) || !inViewport(this)){<br />
                      return;<br />
                    }

                    act($this);

                  })<br />
                }).trigger('scroll');

               // 展示图片<br />
               function act(_self){<br />
                      // 已经加载过了，则中断后续代码<br />
                   if (_self.attr('lazyImgLoaded')) return;<br />
                    var img = new Image(),<br />
                    original = _self.attr('dataimg');<br />
                    // 图片请求完成后的事件，把dataimg指定的图片，放到src里面，浏览器显示<br />
                    img.onload = function() {<br />
                        _self.attr('src', original);<br />
                        anim &amp;&amp; _self.css({ opacity: .2 }).animate({ opacity: 1 }, 280);<br />
                    };<br />
                    // 当你设置img.src的时候，浏览器就在发送图片请求了<br />
                    original &amp;&amp; (img.src = original);<br />
                     _self.attr('lazyImgLoaded', true);<br />
               }<br />
            }<br />
          }<br />
        };

        /*<br />
         * selectorName，要懒加载的选择器名称<br />
         * extend_height  扩展高度<br />
         * anim  是否开启动画<br />
         * realSrcAtr  图片真正地址*/<br />
        lazyload.init({<br />
            anim:false,<br />
            selectorName:".samLazyImg"<br />
        });<br />
    &lt;/script&gt;

&lt;/html&gt;</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pp03k9.html">&lbrack;转&rsqb;ExtJS之遍历Store</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gzm6e8.html">ORACLE 10&period;2&period;01升级10&period;2&period;05 for windows 详细文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qneyygq.html">JMeter之JDBC接口测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdyo47q.html">测试Python代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7447jq.html">Java读数据是的编码问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x3p5z8.html">运行ipython后显示WARNING&colon; IPython History requires SQLite&comma; your history will not be saved</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1nle9.html">iOS 微信支付平台集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/96og0449.html">Java泛型反射机制（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgod0q.html">基于CAS的SSO&lpar;单点登录&rpar;实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z04vg9.html">NSNotification</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mko6n8.html">iframe自适应高度？？？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mev7v2q.html">【BZOJ1040】骑士（动态规划）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1gm59.html">计蒜客NOIP模拟赛5 D1T1 机智的 AmyZhi</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy13j5gq.html">Python模块探秘之EasyGui</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj0nrpq.html">&lpar;NO&period;00003&rpar;iOS游戏简单的机器人投射游戏成形记&lpar;四&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjg2xz8.html">springcloud~配置中心实例搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mdoy9.html">不停机修改线上 MySQL 主键字段 以及其带来的问题和总结思考</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjwprj9.html">SSH无法连上CentOS7的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlk3nz9.html">MongoDB ，cursor not found异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjnrpr8.html">jquery&period;form&period;js 让表单提交更优雅</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90v7kw38.html">JavaScript中统计Textarea字数并提示还能输入的字符</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnwxw08.html">多线程并发流程控制之dispatch&lowbar;group 有关函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1gxzx9.html">Postgres-XL介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1043r9.html">Asp&period;net Vnext  IValueProvider</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v7n738.html">js 对象toString&lpar;&rpar;方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydwnk2q.html">windows上安装apache python mod&lowbar;python</a>
			</li>
						<li><a href="https://www.batexi.com/a/qydwnpgq.html">c&num;之委托所有方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv5wroq.html">20150601&lowbar;Andriod 打开新窗体</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv5m7yq.html">noi 7627 鸡蛋的硬度</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnw3ze8.html">hibernate的dao中参数的传递取值</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
